// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

library omnibus.test.exceptions_test;

import 'package:test/test.dart';
import 'package:omnibus/omnibus.dart';

import 'messages_lib.dart' as v0;

void main() {
  test('Bind null event handler', () {
    expect(() {
      new Omnibus().bindEventHandler(v0.Data.id, {}, null);
    }, throwsArgumentError);
  });

  test('Bind null request handler', () {
    expect(() {
      new Omnibus().bindRequestHandler(v0.FakeRequest.id, {}, null);
    }, throwsArgumentError);
  });

  test('Bind null global event handler', () {
    expect(() {
      new Omnibus().bindGlobalEventHandler(null);
    }, throwsArgumentError);
  });

  test('Bind null global request handler', () {
    expect(() {
      new Omnibus().bindGlobalRequestHandler(null);
    }, throwsArgumentError);
  });

  test('Publish illegal data with JsonIncompatible', () {
    expect(() {
      new Omnibus()
          .publishEvent(new v0.Incompatible(new v0.JsonIncompatible(1)));
    }, throwsNoSuchMethodError);
  });

  test('Publish illegal data with UglyJsonIncompatible', () {
    expect(() {
      new Omnibus().publishEvent(
          new v0.UglyIncompatible(new v0.UglyJsonIncompatible(1)));
    }, throwsArgumentError);
  });
}
