// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

// THIS FILE IS AUTO-GENERATED, PLEASE DO NOT MODIFY BY HAND.

part of omnibus.test.messages_lib;

/// Test messages that are used to test the Omnibus library.

/// Message that can String key/value pairs
class Data extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibus.v0.Data';

  /// Data map
  final Map<String, String> keyval;

  /// Constructor
  Data(final Map<String, String> keyval)
      : keyval = keyval,
        super.unchecked(id, {'keyval': keyval});

  /// Internal constructor for fromJson
  Data._from(final Map<String, dynamic> data, Map<String, String> keyval)
      : keyval = keyval,
        super.unchecked(id, data);

  /// Data map input constructor
  factory Data.fromJson(final Map<String, dynamic> data) {
    Map<String, String> keyval;

    if (data.containsKey('keyval') && data['keyval'] is Map<String, String>) {
      keyval = data['keyval'] as Map<String, String>;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'keyval'");
    }

    return new Data._from(data, keyval);
  }
}

class Incompatible extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibus.v0.Incompatible';

  final JsonIncompatible value;

  /// Constructor
  Incompatible(final JsonIncompatible value)
      : value = value,
        super(id, {'value': value});

  /// Internal constructor for fromJson
  Incompatible._from(final Map<String, dynamic> data, JsonIncompatible value)
      : value = value,
        super(id, data);

  /// Data map input constructor
  factory Incompatible.fromJson(final Map<String, dynamic> data) {
    JsonIncompatible value;

    if (data.containsKey('value') && data['value'] is int) {
      value = new JsonIncompatible.fromJson(data['value'] as int);
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'value'");
    }

    return new Incompatible._from(data, value);
  }
}

class UglyIncompatible extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibus.v0.UglyIncompatible';

  final UglyJsonIncompatible value;

  /// Constructor
  UglyIncompatible(final UglyJsonIncompatible value)
      : value = value,
        super(id, {'value': value});

  /// Internal constructor for fromJson
  UglyIncompatible._from(
      final Map<String, dynamic> data, UglyJsonIncompatible value)
      : value = value,
        super(id, data);

  /// Data map input constructor
  factory UglyIncompatible.fromJson(final Map<String, dynamic> data) {
    UglyJsonIncompatible value;

    if (data.containsKey('value') && data['value'] is int) {
      value = new UglyJsonIncompatible.fromJson(data['value'] as int);
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'value'");
    }

    return new UglyIncompatible._from(data, value);
  }
}

/// Message that has a, b, c values
class Abc extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibus.v0.Abc';

  final String a;

  final String b;

  final String c;

  /// Constructor
  Abc({final String a: '', final String b: '', final String c: ''})
      : a = a,
        b = b,
        c = c,
        super.unchecked(id, {'a': a, 'b': b, 'c': c});

  /// Internal constructor for fromJson
  Abc._from(final Map<String, dynamic> data, String a, String b, String c)
      : a = a,
        b = b,
        c = c,
        super.unchecked(id, data);

  /// Data map input constructor
  factory Abc.fromJson(final Map<String, dynamic> data) {
    String a;
    String b;
    String c;

    if (data.containsKey('a') && data['a'] is String) {
      a = data['a'] as String;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'a'");
    }

    if (data.containsKey('b') && data['b'] is String) {
      b = data['b'] as String;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'b'");
    }

    if (data.containsKey('c') && data['c'] is String) {
      c = data['c'] as String;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'c'");
    }

    return new Abc._from(data, a, b, c);
  }
}

/// Fake request (also used to test for data parsing exceptions)
class FakeRequest extends OmnibusRequest {
  /// omnibusId
  static const id = 'omnibus.v0.FakeRequest';

  /// Data map
  final Map<String, List<int>> mapintlist;

  /// Data map
  final Map<String, List<bool>> mapboollist;

  /// Constructor
  FakeRequest(final Map<String, List<int>> mapintlist,
      final Map<String, List<bool>> mapboollist)
      : mapintlist = mapintlist,
        mapboollist = mapboollist,
        super.unchecked(
            id, {'mapintlist': mapintlist, 'mapboollist': mapboollist});

  /// Internal constructor for fromJson
  FakeRequest._from(final Map<String, dynamic> data,
      Map<String, List<int>> mapintlist, Map<String, List<bool>> mapboollist)
      : mapintlist = mapintlist,
        mapboollist = mapboollist,
        super.unchecked(id, data);

  /// Data map input constructor
  factory FakeRequest.fromJson(final Map<String, dynamic> data) {
    Map<String, List<int>> mapintlist;
    Map<String, List<bool>> mapboollist;

    if (data.containsKey('mapintlist') &&
        data['mapintlist'] is Map<String, List<int>>) {
      mapintlist = data['mapintlist'] as Map<String, List<int>>;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'mapintlist'");
    }

    if (data.containsKey('mapboollist') &&
        data['mapboollist'] is Map<String, List<bool>>) {
      mapboollist = data['mapboollist'] as Map<String, List<bool>>;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'mapboollist'");
    }

    return new FakeRequest._from(data, mapintlist, mapboollist);
  }
}

/// Fake response (also used to test OmnibusResponse.unchecked)
class FakeResponse extends OmnibusResponse {
  /// omnibusId
  static const id = 'omnibus.v0.FakeResponse';

  /// Constructor
  FakeResponse() : super.unchecked(id, {});

  /// Internal constructor for fromJson
  FakeResponse._from(final Map<String, dynamic> data)
      : super.unchecked(id, data);

  /// Data map input constructor
  factory FakeResponse.fromJson(final Map<String, dynamic> data) {
    return new FakeResponse._from(data);
  }
}

/// Condition-less event to test conditions
class MessageForAll extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibus.v0.MessageForAll';

  /// Message text
  final String message;

  /// Constructor
  MessageForAll(final String message)
      : message = message,
        super.unchecked(id, {'message': message});

  /// Internal constructor for fromJson
  MessageForAll._from(final Map<String, dynamic> data, String message)
      : message = message,
        super.unchecked(id, data);

  /// Data map input constructor
  factory MessageForAll.fromJson(final Map<String, dynamic> data) {
    String message;

    if (data.containsKey('message') && data['message'] is String) {
      message = data['message'] as String;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'message'");
    }

    return new MessageForAll._from(data, message);
  }
}

/// Email message
class Email extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibus.v0.Email';

  /// Sender
  final String from;

  /// Receiver
  final String to;

  /// Message body
  final String body;

  /// Constructor
  Email(final String body, {final String from: '', final String to: ''})
      : from = from,
        to = to,
        body = body,
        super.unchecked(id, {'from': from, 'to': to, 'body': body});

  /// Internal constructor for fromJson
  Email._from(
      final Map<String, dynamic> data, String from, String to, String body)
      : from = from,
        to = to,
        body = body,
        super.unchecked(id, data);

  /// Data map input constructor
  factory Email.fromJson(final Map<String, dynamic> data) {
    String from;
    String to;
    String body;

    if (data.containsKey('from') && data['from'] is String) {
      from = data['from'] as String;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'from'");
    }

    if (data.containsKey('to') && data['to'] is String) {
      to = data['to'] as String;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'to'");
    }

    if (data.containsKey('body') && data['body'] is String) {
      body = data['body'] as String;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'body'");
    }

    return new Email._from(data, from, to, body);
  }
}

/// Calculation request message
class CalculationRequest extends OmnibusRequest {
  /// omnibusId
  static const id = 'omnibus.v0.CalculationRequest';

  /// First input
  final double a;

  /// Second input
  final double b;

  /// Mathematical operator
  final CalculationOperator op;

  /// Constructor
  CalculationRequest(
      [final double a = 1.0,
      final double b = 1.0,
      final CalculationOperator op = CalculationOperator.add])
      : a = a,
        b = b,
        op = op,
        super.unchecked(id, {'a': a, 'b': b, 'op': op.index});

  /// Internal constructor for fromJson
  CalculationRequest._from(final Map<String, dynamic> data, double a, double b,
      CalculationOperator op)
      : a = a,
        b = b,
        op = op,
        super.unchecked(id, data);

  /// Data map input constructor
  factory CalculationRequest.fromJson(final Map<String, dynamic> data) {
    double a;
    double b;
    CalculationOperator op;

    if (data.containsKey('a') && data['a'] is double) {
      a = data['a'] as double;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'a'");
    }

    if (data.containsKey('b') && data['b'] is double) {
      b = data['b'] as double;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'b'");
    }

    if (data.containsKey('op') && data['op'] is int) {
      op = CalculationOperator.values[data['op'] as int];
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'op'");
    }

    return new CalculationRequest._from(data, a, b, op);
  }
}

/// Calculation request response
class CalculationResponse extends OmnibusResponse {
  /// omnibusId
  static const id = 'omnibus.v0.CalculationResponse';

  /// Calculation result
  final CalculationResult result;

  /// Constructor
  CalculationResponse(final CalculationResult result)
      : result = result,
        super(id, {'result': result});

  /// Internal constructor for fromJson
  CalculationResponse._from(
      final Map<String, dynamic> data, CalculationResult result)
      : result = result,
        super(id, data);

  /// Data map input constructor
  factory CalculationResponse.fromJson(final Map<String, dynamic> data) {
    CalculationResult result;

    if (data.containsKey('result') && data['result'] is double) {
      result = new CalculationResult.fromJson(data['result'] as double);
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'result'");
    }

    return new CalculationResponse._from(data, result);
  }
}
