// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

library omnibus.test.messages_lib;

import 'package:omnibus/omnibus.dart';

part 'messages.v0.dart';

/// Simple calculation types
enum CalculationOperator { add, subtract, multiply, divide }

/// Storage class for the calculation result to test [toJson]
class CalculationResult {
  final double result;
  CalculationResult(this.result);
  CalculationResult.fromJson(this.result);
  double toJson() => result;
}

/// JSON incompatible data
class JsonIncompatible {
  int number;
  JsonIncompatible(this.number);
  JsonIncompatible.fromJson(this.number);
}

/// toJson with JSON incompatible data
class UglyJsonIncompatible {
  int number;
  UglyJsonIncompatible(this.number);
  UglyJsonIncompatible.fromJson(this.number);
  JsonIncompatible toJson() => new JsonIncompatible(number);
}
